#ifndef ARRAY_SHIELD
#define ARRAY_SHIELD
#include "Array.h"

template<class T> Array<T>::Array()
{
	data = new T[0];
	base = 0;
	length = 0;
}

template<class T> Array<T>::Array(unsigned int array_length, unsigned int array_base = 0)
{
	data = new T[array_length];
	base = array_base;
	length = array_length;
}

template<class T> Array<T>::Array(Array<T> const& the_array)
:	data (new T[the_array.length]),
	base (the_array.base),
	length (the_array.length)
{
	for(int i=0; i<length; i++)
		data[i] = the_array.data[i];
}

template<class T> Array<T>::~Array()
{	delete [] data;	}

//template<class T> T const & Array<T>::Data() const
//{	return data;	}

template<class T> unsigned int Array<T>::Base() const
{	return base;	}

template<class T> unsigned int Array<T>::Length() const
{	return length;	}

template<class T> T const& Array<T>::operator [](unsigned int position) const
{
	unsigned int const offset = position - base;
	if(offset >= length)
		throw out_of_range("invalid position");
	return data[offset];
}

template<class T> T& Array<T>::operator [] (unsigned int position)
{
	unsigned int const offset = position - base;
	if(offset >= length)
		throw out_of_range("invalid position");
	return data[offset];
}

template<class T> void Array<T>::SetBase(unsigned int new_base)
{	base = new_base;	}

template<class T> void Array<T>::SetLength(unsigned int new_length)
{
	T* const newData = new T[new_length];
	unsigned int const min = 
		length < new_length ? length: new_length;
	for(int i=0; i<min; i++)
		newData[i] = data[i];
	delete [] data;
	data = newData;
	length = new_length;
}
#endif